package com.nisum.ascend.promotions.service;

import com.nisum.ascend.promotions.dto.PromotionDto;
import com.nisum.ascend.promotions.model.Promotion;
import com.nisum.ascend.promotions.repository.PromotionRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class PromotionService {

    @Autowired
    PromotionRepository promotionRepository;

    public Flux<PromotionDto> findAll(){
        return promotionRepository.findAll().map(PromotionDto::generateDtoFromPromotion);
    }

    public Flux<PromotionDto> findPromotionsByProductSku(String sku){
        return promotionRepository.findByProductSku(sku).map(PromotionDto::generateDtoFromPromotion);
    }

    public Mono<PromotionDto> createPromotion(Promotion promotion){
        return promotionRepository.save(promotion).map(PromotionDto::generateDtoFromPromotion);
    }
}
